package examples.theatre;


import java.util.List;
import de.tfhberlin.crempel.util.Maybe;

public class ACT implements ACTVisitable{
  private TITLE theTITLE;
  private List<SUBTITLE> theList_SUBTITLE_;
  private Maybe<PROLOGUE> theMaybe_PROLOGUE_;
  private List<SCENE> theList_SCENE_;
  private Maybe<EPILOGUE> theMaybe_EPILOGUE_;

  public ACT(TITLE theTITLE,List<SUBTITLE> theList_SUBTITLE_,Maybe<PROLOGUE> theMaybe_PROLOGUE_,List<SCENE> theList_SCENE_,Maybe<EPILOGUE> theMaybe_EPILOGUE_){
    this.theTITLE = theTITLE;
    this.theList_SUBTITLE_ = theList_SUBTITLE_;
    this.theMaybe_PROLOGUE_ = theMaybe_PROLOGUE_;
    this.theList_SCENE_ = theList_SCENE_;
    this.theMaybe_EPILOGUE_ = theMaybe_EPILOGUE_;
  }

  public TITLE getTheTITLE(){return theTITLE;}
  public List<SUBTITLE> getTheList_SUBTITLE_(){return theList_SUBTITLE_;}
  public Maybe<PROLOGUE> getTheMaybe_PROLOGUE_(){return theMaybe_PROLOGUE_;}
  public List<SCENE> getTheList_SCENE_(){return theList_SCENE_;}
  public Maybe<EPILOGUE> getTheMaybe_EPILOGUE_(){return theMaybe_EPILOGUE_;}
  public <_b> _b visit(ACTVisitor<_b> visitor){
    return visitor.eval(this);
  }
  public String toString(){
    return "ACT("+theTITLE+","+theList_SUBTITLE_+","+theMaybe_PROLOGUE_+","+theList_SCENE_+","+theMaybe_EPILOGUE_+")";
  }
  public boolean equals(Object other){
    if (!(other instanceof ACT)) return false;
    final ACT o= (ACT) other;
    return true  &&theTITLE.equals(o.theTITLE)&&theList_SUBTITLE_.equals(o.theList_SUBTITLE_)&&theMaybe_PROLOGUE_.equals(o.theMaybe_PROLOGUE_)&&theList_SCENE_.equals(o.theList_SCENE_)&&theMaybe_EPILOGUE_.equals(o.theMaybe_EPILOGUE_);
  }
}
