package examples.theatre;


import java.util.List;
import de.tfhberlin.crempel.util.Maybe;

public class LINE implements LINEVisitable{
  private List<Choice_String_STAGEDIR> xs;

  public LINE(List<Choice_String_STAGEDIR> xs){
    this.xs = xs;
  }

  public List<Choice_String_STAGEDIR> getXs(){return xs;}
  public <_b> _b visit(LINEVisitor<_b> visitor){
    return visitor.eval(this);
  }
  public String toString(){
    return "LINE("+xs+")";
  }
  public boolean equals(Object other){
    if (!(other instanceof LINE)) return false;
    final LINE o= (LINE) other;
    return true  &&xs.equals(o.xs);
  }
}
