package examples.theatre;
import de.tfhberlin.crempel.util.xml.parslib.*;
import de.tfhberlin.crempel.util.*;
import java.util.*;
import org.w3c.dom.Node;

public class PLAYParser extends AbstractParser<PLAY>{
public ParseResult<PLAY>parse(List<Node> xs){  return getVPLAY().parse(xs);}



  private Parser<ACT>vACT = null;
  public Parser<ACT>getVACT(){
    if (vACT==null){
      vACT = new Element<ACT>("ACT",getVTITLE().seq(getVSUBTITLE().star()).seq(getVPROLOGUE().query()).seq(getVSCENE().plus()).seq(getVEPILOGUE().query()).map(new UnaryFunction<Tuple2<Tuple2<Tuple2<Tuple2<TITLE,List<SUBTITLE>>,Maybe<PROLOGUE>>,List<SCENE>>,Maybe<EPILOGUE>>,ACT>(){
    public ACT eval(Tuple2<Tuple2<Tuple2<Tuple2<TITLE,List<SUBTITLE>>,Maybe<PROLOGUE>>,List<SCENE>>,Maybe<EPILOGUE>> p){
      return new ACT(p.e1.e1.e1.e1,p.e1.e1.e1.e2,p.e1.e1.e2,p.e1.e2,p.e2);
    }
  }));
    }
    return vACT;
  }

  private Parser<Choice_LINE_STAGEDIR_SUBHEAD>vChoice_LINE_STAGEDIR_SUBHEAD = null;
  public Parser<Choice_LINE_STAGEDIR_SUBHEAD>getVChoice_LINE_STAGEDIR_SUBHEAD(){
    if (vChoice_LINE_STAGEDIR_SUBHEAD==null){
      vChoice_LINE_STAGEDIR_SUBHEAD = getVLINE().<Choice_LINE_STAGEDIR_SUBHEAD>map(new UnaryFunction<LINE,Choice_LINE_STAGEDIR_SUBHEAD>(){
    public Choice_LINE_STAGEDIR_SUBHEAD eval(LINE x){
      return (Choice_LINE_STAGEDIR_SUBHEAD)new CChoice_LINE_STAGEDIR_SUBHEADLINE(x);
    }
  }).choice(getVSTAGEDIR().<Choice_LINE_STAGEDIR_SUBHEAD>map(new UnaryFunction<STAGEDIR,Choice_LINE_STAGEDIR_SUBHEAD>(){
    public Choice_LINE_STAGEDIR_SUBHEAD eval(STAGEDIR x){
      return (Choice_LINE_STAGEDIR_SUBHEAD)new CChoice_LINE_STAGEDIR_SUBHEADSTAGEDIR(x);
    }
  })).choice(getVSUBHEAD().<Choice_LINE_STAGEDIR_SUBHEAD>map(new UnaryFunction<SUBHEAD,Choice_LINE_STAGEDIR_SUBHEAD>(){
    public Choice_LINE_STAGEDIR_SUBHEAD eval(SUBHEAD x){
      return (Choice_LINE_STAGEDIR_SUBHEAD)new CChoice_LINE_STAGEDIR_SUBHEADSUBHEAD(x);
    }
  }));
    }
    return vChoice_LINE_STAGEDIR_SUBHEAD;
  }

  private Parser<Choice_List_SCENE__List_Choice_SPEECH_STAGEDIR_SUBHEAD_>vChoice_List_SCENE__List_Choice_SPEECH_STAGEDIR_SUBHEAD_ = null;
  public Parser<Choice_List_SCENE__List_Choice_SPEECH_STAGEDIR_SUBHEAD_>getVChoice_List_SCENE__List_Choice_SPEECH_STAGEDIR_SUBHEAD_(){
    if (vChoice_List_SCENE__List_Choice_SPEECH_STAGEDIR_SUBHEAD_==null){
      vChoice_List_SCENE__List_Choice_SPEECH_STAGEDIR_SUBHEAD_ = new Element<Choice_List_SCENE__List_Choice_SPEECH_STAGEDIR_SUBHEAD_>("Choice_List_SCENE__List_Choice_SPEECH_STAGEDIR_SUBHEAD_",getVSCENE().plus().<Choice_List_SCENE__List_Choice_SPEECH_STAGEDIR_SUBHEAD_>map(new UnaryFunction<List<SCENE>,Choice_List_SCENE__List_Choice_SPEECH_STAGEDIR_SUBHEAD_>(){
    public Choice_List_SCENE__List_Choice_SPEECH_STAGEDIR_SUBHEAD_ eval(List<SCENE> x){
      return (Choice_List_SCENE__List_Choice_SPEECH_STAGEDIR_SUBHEAD_)new CChoice_List_SCENE__List_Choice_SPEECH_STAGEDIR_SUBHEAD_List_SCENE_(x);
    }
  }).choice(getVChoice_SPEECH_STAGEDIR_SUBHEAD().plus().<Choice_List_SCENE__List_Choice_SPEECH_STAGEDIR_SUBHEAD_>map(new UnaryFunction<List<Choice_SPEECH_STAGEDIR_SUBHEAD>,Choice_List_SCENE__List_Choice_SPEECH_STAGEDIR_SUBHEAD_>(){
    public Choice_List_SCENE__List_Choice_SPEECH_STAGEDIR_SUBHEAD_ eval(List<Choice_SPEECH_STAGEDIR_SUBHEAD> x){
      return (Choice_List_SCENE__List_Choice_SPEECH_STAGEDIR_SUBHEAD_)new CChoice_List_SCENE__List_Choice_SPEECH_STAGEDIR_SUBHEAD_List_Choice_SPEECH_STAGEDIR_SUBHEAD_(x);
    }
  })));
    }
    return vChoice_List_SCENE__List_Choice_SPEECH_STAGEDIR_SUBHEAD_;
  }

  private Parser<Choice_PERSONA_PGROUP>vChoice_PERSONA_PGROUP = null;
  public Parser<Choice_PERSONA_PGROUP>getVChoice_PERSONA_PGROUP(){
    if (vChoice_PERSONA_PGROUP==null){
      vChoice_PERSONA_PGROUP = getVPERSONA().<Choice_PERSONA_PGROUP>map(new UnaryFunction<PERSONA,Choice_PERSONA_PGROUP>(){
    public Choice_PERSONA_PGROUP eval(PERSONA x){
      return (Choice_PERSONA_PGROUP)new CChoice_PERSONA_PGROUPPERSONA(x);
    }
  }).choice(getVPGROUP().<Choice_PERSONA_PGROUP>map(new UnaryFunction<PGROUP,Choice_PERSONA_PGROUP>(){
    public Choice_PERSONA_PGROUP eval(PGROUP x){
      return (Choice_PERSONA_PGROUP)new CChoice_PERSONA_PGROUPPGROUP(x);
    }
  }));
    }
    return vChoice_PERSONA_PGROUP;
  }

  private Parser<Choice_SPEECH_STAGEDIR_SUBHEAD>vChoice_SPEECH_STAGEDIR_SUBHEAD = null;
  public Parser<Choice_SPEECH_STAGEDIR_SUBHEAD>getVChoice_SPEECH_STAGEDIR_SUBHEAD(){
    if (vChoice_SPEECH_STAGEDIR_SUBHEAD==null){
      vChoice_SPEECH_STAGEDIR_SUBHEAD = getVSPEECH().<Choice_SPEECH_STAGEDIR_SUBHEAD>map(new UnaryFunction<SPEECH,Choice_SPEECH_STAGEDIR_SUBHEAD>(){
    public Choice_SPEECH_STAGEDIR_SUBHEAD eval(SPEECH x){
      return (Choice_SPEECH_STAGEDIR_SUBHEAD)new CChoice_SPEECH_STAGEDIR_SUBHEADSPEECH(x);
    }
  }).choice(getVSTAGEDIR().<Choice_SPEECH_STAGEDIR_SUBHEAD>map(new UnaryFunction<STAGEDIR,Choice_SPEECH_STAGEDIR_SUBHEAD>(){
    public Choice_SPEECH_STAGEDIR_SUBHEAD eval(STAGEDIR x){
      return (Choice_SPEECH_STAGEDIR_SUBHEAD)new CChoice_SPEECH_STAGEDIR_SUBHEADSTAGEDIR(x);
    }
  })).choice(getVSUBHEAD().<Choice_SPEECH_STAGEDIR_SUBHEAD>map(new UnaryFunction<SUBHEAD,Choice_SPEECH_STAGEDIR_SUBHEAD>(){
    public Choice_SPEECH_STAGEDIR_SUBHEAD eval(SUBHEAD x){
      return (Choice_SPEECH_STAGEDIR_SUBHEAD)new CChoice_SPEECH_STAGEDIR_SUBHEADSUBHEAD(x);
    }
  }));
    }
    return vChoice_SPEECH_STAGEDIR_SUBHEAD;
  }

  private Parser<Choice_STAGEDIR_SPEECH>vChoice_STAGEDIR_SPEECH = null;
  public Parser<Choice_STAGEDIR_SPEECH>getVChoice_STAGEDIR_SPEECH(){
    if (vChoice_STAGEDIR_SPEECH==null){
      vChoice_STAGEDIR_SPEECH = getVSTAGEDIR().<Choice_STAGEDIR_SPEECH>map(new UnaryFunction<STAGEDIR,Choice_STAGEDIR_SPEECH>(){
    public Choice_STAGEDIR_SPEECH eval(STAGEDIR x){
      return (Choice_STAGEDIR_SPEECH)new CChoice_STAGEDIR_SPEECHSTAGEDIR(x);
    }
  }).choice(getVSPEECH().<Choice_STAGEDIR_SPEECH>map(new UnaryFunction<SPEECH,Choice_STAGEDIR_SPEECH>(){
    public Choice_STAGEDIR_SPEECH eval(SPEECH x){
      return (Choice_STAGEDIR_SPEECH)new CChoice_STAGEDIR_SPEECHSPEECH(x);
    }
  }));
    }
    return vChoice_STAGEDIR_SPEECH;
  }

  private Parser<Choice_String_STAGEDIR>vChoice_String_STAGEDIR = null;
  public Parser<Choice_String_STAGEDIR>getVChoice_String_STAGEDIR(){
    if (vChoice_String_STAGEDIR==null){
      vChoice_String_STAGEDIR = new PCData().<Choice_String_STAGEDIR>map(new UnaryFunction<String,Choice_String_STAGEDIR>(){
    public Choice_String_STAGEDIR eval(String x){
      return (Choice_String_STAGEDIR)new CChoice_String_STAGEDIRString(x);
    }
  }).choice(getVSTAGEDIR().<Choice_String_STAGEDIR>map(new UnaryFunction<STAGEDIR,Choice_String_STAGEDIR>(){
    public Choice_String_STAGEDIR eval(STAGEDIR x){
      return (Choice_String_STAGEDIR)new CChoice_String_STAGEDIRSTAGEDIR(x);
    }
  }));
    }
    return vChoice_String_STAGEDIR;
  }

  private Parser<EPILOGUE>vEPILOGUE = null;
  public Parser<EPILOGUE>getVEPILOGUE(){
    if (vEPILOGUE==null){
      vEPILOGUE = new Element<EPILOGUE>("EPILOGUE",getVTITLE().seq(getVSUBTITLE().star()).seq(getVChoice_STAGEDIR_SPEECH().plus()).map(new UnaryFunction<Tuple2<Tuple2<TITLE,List<SUBTITLE>>,List<Choice_STAGEDIR_SPEECH>>,EPILOGUE>(){
    public EPILOGUE eval(Tuple2<Tuple2<TITLE,List<SUBTITLE>>,List<Choice_STAGEDIR_SPEECH>> p){
      return new EPILOGUE(p.e1.e1,p.e1.e2,p.e2);
    }
  }));
    }
    return vEPILOGUE;
  }

  private Parser<FM>vFM = null;
  public Parser<FM>getVFM(){
    if (vFM==null){
      vFM = new Element<FM>("FM",getVP().plus()
     .<FM>map(new UnaryFunction<List<P>,FM>(){
       public FM eval(List<P> x){
         return new FM(x);
       }
     }));
    }
    return vFM;
  }

  private Parser<GRPDESCR>vGRPDESCR = null;
  public Parser<GRPDESCR>getVGRPDESCR(){
    if (vGRPDESCR==null){
      vGRPDESCR = new Element<GRPDESCR>("GRPDESCR",new PCData()
     .<GRPDESCR>map(new UnaryFunction<String,GRPDESCR>(){
       public GRPDESCR eval(String x){
         return new GRPDESCR(x);
       }
     }));
    }
    return vGRPDESCR;
  }

  private Parser<INDUCT>vINDUCT = null;
  public Parser<INDUCT>getVINDUCT(){
    if (vINDUCT==null){
      vINDUCT = new Element<INDUCT>("INDUCT",getVTITLE().seq(getVSUBTITLE().star()).seq(getVChoice_List_SCENE__List_Choice_SPEECH_STAGEDIR_SUBHEAD_()).map(new UnaryFunction<Tuple2<Tuple2<TITLE,List<SUBTITLE>>,Choice_List_SCENE__List_Choice_SPEECH_STAGEDIR_SUBHEAD_>,INDUCT>(){
    public INDUCT eval(Tuple2<Tuple2<TITLE,List<SUBTITLE>>,Choice_List_SCENE__List_Choice_SPEECH_STAGEDIR_SUBHEAD_> p){
      return new INDUCT(p.e1.e1,p.e1.e2,p.e2);
    }
  }));
    }
    return vINDUCT;
  }

  private Parser<LINE>vLINE = null;
  public Parser<LINE>getVLINE(){
    if (vLINE==null){
      vLINE = new Element<LINE>("LINE",getVChoice_String_STAGEDIR().star()
     .<LINE>map(new UnaryFunction<List<Choice_String_STAGEDIR>,LINE>(){
       public LINE eval(List<Choice_String_STAGEDIR> x){
         return new LINE(x);
       }
     }));
    }
    return vLINE;
  }

  private Parser<P>vP = null;
  public Parser<P>getVP(){
    if (vP==null){
      vP = new Element<P>("P",new PCData()
     .<P>map(new UnaryFunction<String,P>(){
       public P eval(String x){
         return new P(x);
       }
     }));
    }
    return vP;
  }

  private Parser<PERSONA>vPERSONA = null;
  public Parser<PERSONA>getVPERSONA(){
    if (vPERSONA==null){
      vPERSONA = new Element<PERSONA>("PERSONA",new PCData()
     .<PERSONA>map(new UnaryFunction<String,PERSONA>(){
       public PERSONA eval(String x){
         return new PERSONA(x);
       }
     }));
    }
    return vPERSONA;
  }

  private Parser<PERSONAE>vPERSONAE = null;
  public Parser<PERSONAE>getVPERSONAE(){
    if (vPERSONAE==null){
      vPERSONAE = new Element<PERSONAE>("PERSONAE",getVTITLE().seq(getVChoice_PERSONA_PGROUP().plus()).map(new UnaryFunction<Tuple2<TITLE,List<Choice_PERSONA_PGROUP>>,PERSONAE>(){
    public PERSONAE eval(Tuple2<TITLE,List<Choice_PERSONA_PGROUP>> p){
      return new PERSONAE(p.e1,p.e2);
    }
  }));
    }
    return vPERSONAE;
  }

  private Parser<PGROUP>vPGROUP = null;
  public Parser<PGROUP>getVPGROUP(){
    if (vPGROUP==null){
      vPGROUP = new Element<PGROUP>("PGROUP",getVPERSONA().plus().seq(getVGRPDESCR()).map(new UnaryFunction<Tuple2<List<PERSONA>,GRPDESCR>,PGROUP>(){
    public PGROUP eval(Tuple2<List<PERSONA>,GRPDESCR> p){
      return new PGROUP(p.e1,p.e2);
    }
  }));
    }
    return vPGROUP;
  }

  private Parser<PLAY>vPLAY = null;
  public Parser<PLAY>getVPLAY(){
    if (vPLAY==null){
      vPLAY = new Element<PLAY>("PLAY",getVTITLE().seq(getVFM()).seq(getVPERSONAE()).seq(getVSCNDESCR()).seq(getVPLAYSUBT()).seq(getVINDUCT().query()).seq(getVPROLOGUE().query()).seq(getVACT().plus()).seq(getVEPILOGUE().query()).map(new UnaryFunction<Tuple2<Tuple2<Tuple2<Tuple2<Tuple2<Tuple2<Tuple2<Tuple2<TITLE,FM>,PERSONAE>,SCNDESCR>,PLAYSUBT>,Maybe<INDUCT>>,Maybe<PROLOGUE>>,List<ACT>>,Maybe<EPILOGUE>>,PLAY>(){
    public PLAY eval(Tuple2<Tuple2<Tuple2<Tuple2<Tuple2<Tuple2<Tuple2<Tuple2<TITLE,FM>,PERSONAE>,SCNDESCR>,PLAYSUBT>,Maybe<INDUCT>>,Maybe<PROLOGUE>>,List<ACT>>,Maybe<EPILOGUE>> p){
      return new PLAY(p.e1.e1.e1.e1.e1.e1.e1.e1,p.e1.e1.e1.e1.e1.e1.e1.e2,p.e1.e1.e1.e1.e1.e1.e2,p.e1.e1.e1.e1.e1.e2,p.e1.e1.e1.e1.e2,p.e1.e1.e1.e2,p.e1.e1.e2,p.e1.e2,p.e2);
    }
  }));
    }
    return vPLAY;
  }

  private Parser<PLAYSUBT>vPLAYSUBT = null;
  public Parser<PLAYSUBT>getVPLAYSUBT(){
    if (vPLAYSUBT==null){
      vPLAYSUBT = new Element<PLAYSUBT>("PLAYSUBT",new PCData()
     .<PLAYSUBT>map(new UnaryFunction<String,PLAYSUBT>(){
       public PLAYSUBT eval(String x){
         return new PLAYSUBT(x);
       }
     }));
    }
    return vPLAYSUBT;
  }

  private Parser<PROLOGUE>vPROLOGUE = null;
  public Parser<PROLOGUE>getVPROLOGUE(){
    if (vPROLOGUE==null){
      vPROLOGUE = new Element<PROLOGUE>("PROLOGUE",getVTITLE().seq(getVSUBTITLE().star()).seq(getVChoice_STAGEDIR_SPEECH().plus()).map(new UnaryFunction<Tuple2<Tuple2<TITLE,List<SUBTITLE>>,List<Choice_STAGEDIR_SPEECH>>,PROLOGUE>(){
    public PROLOGUE eval(Tuple2<Tuple2<TITLE,List<SUBTITLE>>,List<Choice_STAGEDIR_SPEECH>> p){
      return new PROLOGUE(p.e1.e1,p.e1.e2,p.e2);
    }
  }));
    }
    return vPROLOGUE;
  }

  private Parser<SCENE>vSCENE = null;
  public Parser<SCENE>getVSCENE(){
    if (vSCENE==null){
      vSCENE = new Element<SCENE>("SCENE",getVTITLE().seq(getVSUBTITLE().star()).seq(getVChoice_SPEECH_STAGEDIR_SUBHEAD().plus()).map(new UnaryFunction<Tuple2<Tuple2<TITLE,List<SUBTITLE>>,List<Choice_SPEECH_STAGEDIR_SUBHEAD>>,SCENE>(){
    public SCENE eval(Tuple2<Tuple2<TITLE,List<SUBTITLE>>,List<Choice_SPEECH_STAGEDIR_SUBHEAD>> p){
      return new SCENE(p.e1.e1,p.e1.e2,p.e2);
    }
  }));
    }
    return vSCENE;
  }

  private Parser<SCNDESCR>vSCNDESCR = null;
  public Parser<SCNDESCR>getVSCNDESCR(){
    if (vSCNDESCR==null){
      vSCNDESCR = new Element<SCNDESCR>("SCNDESCR",new PCData()
     .<SCNDESCR>map(new UnaryFunction<String,SCNDESCR>(){
       public SCNDESCR eval(String x){
         return new SCNDESCR(x);
       }
     }));
    }
    return vSCNDESCR;
  }

  private Parser<SPEAKER>vSPEAKER = null;
  public Parser<SPEAKER>getVSPEAKER(){
    if (vSPEAKER==null){
      vSPEAKER = new Element<SPEAKER>("SPEAKER",new PCData()
     .<SPEAKER>map(new UnaryFunction<String,SPEAKER>(){
       public SPEAKER eval(String x){
         return new SPEAKER(x);
       }
     }));
    }
    return vSPEAKER;
  }

  private Parser<SPEECH>vSPEECH = null;
  public Parser<SPEECH>getVSPEECH(){
    if (vSPEECH==null){
      vSPEECH = new Element<SPEECH>("SPEECH",getVSPEAKER().plus().seq(getVChoice_LINE_STAGEDIR_SUBHEAD().plus()).map(new UnaryFunction<Tuple2<List<SPEAKER>,List<Choice_LINE_STAGEDIR_SUBHEAD>>,SPEECH>(){
    public SPEECH eval(Tuple2<List<SPEAKER>,List<Choice_LINE_STAGEDIR_SUBHEAD>> p){
      return new SPEECH(p.e1,p.e2);
    }
  }));
    }
    return vSPEECH;
  }

  private Parser<STAGEDIR>vSTAGEDIR = null;
  public Parser<STAGEDIR>getVSTAGEDIR(){
    if (vSTAGEDIR==null){
      vSTAGEDIR = new Element<STAGEDIR>("STAGEDIR",new PCData()
     .<STAGEDIR>map(new UnaryFunction<String,STAGEDIR>(){
       public STAGEDIR eval(String x){
         return new STAGEDIR(x);
       }
     }));
    }
    return vSTAGEDIR;
  }

  private Parser<SUBHEAD>vSUBHEAD = null;
  public Parser<SUBHEAD>getVSUBHEAD(){
    if (vSUBHEAD==null){
      vSUBHEAD = new Element<SUBHEAD>("SUBHEAD",new PCData()
     .<SUBHEAD>map(new UnaryFunction<String,SUBHEAD>(){
       public SUBHEAD eval(String x){
         return new SUBHEAD(x);
       }
     }));
    }
    return vSUBHEAD;
  }

  private Parser<SUBTITLE>vSUBTITLE = null;
  public Parser<SUBTITLE>getVSUBTITLE(){
    if (vSUBTITLE==null){
      vSUBTITLE = new Element<SUBTITLE>("SUBTITLE",new PCData()
     .<SUBTITLE>map(new UnaryFunction<String,SUBTITLE>(){
       public SUBTITLE eval(String x){
         return new SUBTITLE(x);
       }
     }));
    }
    return vSUBTITLE;
  }

  private Parser<TITLE>vTITLE = null;
  public Parser<TITLE>getVTITLE(){
    if (vTITLE==null){
      vTITLE = new Element<TITLE>("TITLE",new PCData()
     .<TITLE>map(new UnaryFunction<String,TITLE>(){
       public TITLE eval(String x){
         return new TITLE(x);
       }
     }));
    }
    return vTITLE;
  }}